# &adminguide;

## Overview

The Perl Virtual Database (VDB) provides a virtualization framework for &kamailio;'s database access. It does not handle a particular database engine itself but lets the user relay database requests to arbitrary Perl functions.

This module cannot be used "out of the box". The user has to supply functionality dedicated to the client module. See below for options.

The module can be used in all current &kamailio; modules that need database access. Relaying of insert, update, query and delete operations is supported.

Modules can be configured to use the db_perlvdb module as database backend using the db_url_parameter:

    modparam("acc", "db_url", "perlvdb:Kamailio::VDB::Adapter::AccountingSIPtrace")

This configuration options tells acc module that it should use the db_perlvdb module which will in turn use the Perl class Kamailio::VDB::Adapter::AccountingSIPtrace to relay the database requests.

## Dependencies

### &kamailio; Modules

The following modules must be loaded before this module:

- app_perl -- Perl Application module

### External Libraries or Applications

The following libraries or applications must be installed before running &kamailio; with this module loaded:

- None (Besides the ones mentioned in the app_perl module documentation).

## Parameters

None.

## Functions

None.